/* ***************************  Definitions  ************************** */

DEFINE BUFFER b-ca-u_shipment        FOR ca-u_shipment.
DEFINE BUFFER b-ca-u_booking         FOR ca-u_booking.
DEFINE VARIABLE cNumPart          AS CHARACTER  NO-UNDO.
DEFINE VARIABLE iLoop             AS INTEGER    NO-UNDO.
DEFINE VARIABLE iStart            AS INTEGER    NO-UNDO INITIAL 1. /*1=offset waarde*/

/* ***************************  Main Block  *************************** */

/****************************************************************************************** 
 Van het bookingnr veld het numerieke deel opslaan IN bookingnr_num_part                 
 naar aanleiding van call 90320-982 tbv Eucon                                            
 Omdat de aangepaste dbtrigger waarschijnlijk nog niet beschikbaar is, 
 doen we hier alsnog vullen. 
 we nemen uit bookingnr alleen seqno deel en year deel.                                             
 ******************************************************************************************/
DISABLE TRIGGERS FOR LOAD OF ca-u_shipment.
DISABLE TRIGGERS FOR LOAD OF ca-u_booking.

FOR EACH ca-u_line_parameters NO-LOCK:
   
   shipment:
   FOR EACH ca-u_shipment WHERE 
            ca-u_shipment.companycode EQ ca-u_line_parameters.companycode AND
            ca-u_shipment.linecode    EQ ca-u_line_parameters.linecode
            NO-LOCK:
      DO iLoop = 1 TO 7: /*-- begin positie bereken door de hele opbouw van bookingnr te doorlopen (iStart) --*/
         CASE iLoop:
            WHEN ca-u_line_parameters.bknr_seqnr_seqno      THEN ASSIGN cNumPart       = cNumPart       + SUBSTRING( ca-u_shipment.bookingnr, iStart, ca-u_line_parameters.bknr_seqnr_length )
                                                                        iStart         = iStart         + ca-u_line_parameters.bknr_seqnr_length.
            WHEN ca-u_line_parameters.bknr_year_seqno       THEN ASSIGN cNumPart       = cNumPart       + SUBSTRING( ca-u_shipment.bookingnr, iStart, ca-u_line_parameters.bknr_year_length )
                                                                        iStart         = iStart         + ca-u_line_parameters.bknr_year_length.
            WHEN ca-u_line_parameters.bknr_pod_seqno        THEN ASSIGN iStart         = iStart         + ca-u_line_parameters.bknr_pod_length.
            WHEN ca-u_line_parameters.bknr_pol_seqno        THEN ASSIGN iStart         = iStart         + ca-u_line_parameters.bknr_pol_length.
            WHEN ca-u_line_parameters.bknr_scac_code_seqno  THEN ASSIGN iStart         = iStart         + ca-u_line_parameters.bknr_scac_code_length.
            WHEN ca-u_line_parameters.bknr_text_seqno       THEN ASSIGN iStart         = iStart         + LENGTH( ca-u_line_parameters.bknr_text ).
            WHEN ca-u_line_parameters.bknr_voyage_seqno     THEN ASSIGN iStart         = iStart         + ca-u_line_parameters.bknr_voyage_length.
         END CASE.
      END. /*do iLoop*/
      DO TRANSACTION:
         FIND b-ca-u_shipment WHERE
              ROWID(b-ca-u_shipment) EQ ROWID(ca-u_shipment)
              EXCLUSIVE-LOCK.
         ASSIGN b-ca-u_shipment.bookingnr_num_part = cNumPart.
      END. /*transaction*/
   END. /*each shipment*/
   
   /*-- reset variables --*/
   ASSIGN iStart   = 1
          cNumPart = ''.
   
   booking:
   FOR EACH ca-u_booking WHERE 
            ca-u_booking.companycode EQ ca-u_line_parameters.companycode AND 
            ca-u_booking.linecode    EQ ca-u_line_parameters.linecode        
            NO-LOCK:
      DO iLoop = 1 TO 7: /*-- begin positie bereken door de hele opbouw van bookingnr te doorlopen (iStart) --*/
         CASE iLoop:
            WHEN ca-u_line_parameters.bknr_seqnr_seqno      THEN ASSIGN cNumPart       = cNumPart       + SUBSTRING( ca-u_booking.bookingnr, iStart, ca-u_line_parameters.bknr_seqnr_length )
                                                                        iStart         = iStart         + ca-u_line_parameters.bknr_seqnr_length.
            WHEN ca-u_line_parameters.bknr_year_seqno       THEN ASSIGN cNumPart       = cNumPart       + SUBSTRING( ca-u_booking.bookingnr, iStart, ca-u_line_parameters.bknr_year_length )
                                                                        iStart         = iStart         + ca-u_line_parameters.bknr_year_length.
            WHEN ca-u_line_parameters.bknr_pod_seqno        THEN ASSIGN iStart         = iStart         + ca-u_line_parameters.bknr_pod_length.
            WHEN ca-u_line_parameters.bknr_pol_seqno        THEN ASSIGN iStart         = iStart         + ca-u_line_parameters.bknr_pol_length.
            WHEN ca-u_line_parameters.bknr_scac_code_seqno  THEN ASSIGN iStart         = iStart         + ca-u_line_parameters.bknr_scac_code_length.
            WHEN ca-u_line_parameters.bknr_text_seqno       THEN ASSIGN iStart         = iStart         + LENGTH( ca-u_line_parameters.bknr_text ).
            WHEN ca-u_line_parameters.bknr_voyage_seqno     THEN ASSIGN iStart         = iStart         + ca-u_line_parameters.bknr_voyage_length.
         END CASE.
      END. /*do iLoop*/
      DO TRANSACTION:
         FIND b-ca-u_booking WHERE
              ROWID(b-ca-u_booking) EQ ROWID(ca-u_booking)
              EXCLUSIVE-LOCK.
         ASSIGN b-ca-u_booking.bookingnr_num_part = cNumPart.
      END. /*transaction*/
   END. /*each booking*/

END. /*each line parameters*/


