/* ***************************  Definitions  ************************** */
DEF VAR hSourceBuffer AS HANDLE NO-UNDO.
DEF VAR hTargetBuffer AS HANDLE NO-UNDO.
DEF VAR hField        AS HANDLE NO-UNDO.

/* ***************************  Main Block  *************************** */

/****************************************************************************************** 
voor de patch 9.2 is het veld remark tijdelijk in een ongebruikte tabel opgeslagen
met release 9.3 is dit veld alsnog beschikbaar gekomen. Nu echter de remarks overhuizen
van de dummy tabel naar de eigenlijke tabel en het oude record weggooien.                                            
 ******************************************************************************************/
   DISABLE TRIGGERS FOR LOAD OF ca-u_shipment_item_address_old.
   DISABLE TRIGGERS FOR LOAD OF ca-i_shipment_item_address.

   /*-- remarks in hulp tabel opzoeken --*/
   CREATE BUFFER hSourceBuffer FOR TABLE 'ca-u_shipment_item_address_old'.
   CREATE BUFFER hTargetBuffer FOR TABLE 'ca-i_shipment_item_address'.
   FOR EACH ca-u_shipment_item_address_old WHERE
            ca-u_shipment_item_address_old.NAW EQ 'ca-i_shipment_item_address'
            NO-LOCK:
       DO TRANSACTION:
          FOR EACH ca-i_shipment_item_address WHERE
                   ca-i_shipment_item_address.companycode    EQ ca-u_shipment_item_address_old.companycode   
               AND ca-i_shipment_item_address.shipment_seqnr EQ ca-u_shipment_item_address_old.shipment_seqnr
               AND ca-i_shipment_item_address.item_seqnr     EQ ca-u_shipment_item_address_old.item_seqnr    
               AND ca-i_shipment_item_address.qualifier      EQ ca-u_shipment_item_address_old.qualifier     
               NO-LOCK:
             hTargetBuffer:FIND-BY-ROWID( ROWID(ca-i_shipment_item_address), EXCLUSIVE-LOCK).
             ASSIGN hField              = hTargetBuffer:BUFFER-FIELD('remarks')
                    hField:BUFFER-VALUE = ca-u_shipment_item_address_old.NAW1.
             hTargetBuffer:BUFFER-RELEASE().
          END. /*each*/
          hSourceBuffer:FIND-BY-ROWID( ROWID(ca-u_shipment_item_address_old), EXCLUSIVE-LOCK).
          hSourceBuffer:BUFFER-DELETE().
      END. /*transaction*/
   END. /*each*/     
   DELETE OBJECT hSourceBuffer.
   DELETE OBJECT hTargetBuffer.


