/*-- vanaf 11.4 wordt aa-vessel.dtm_ets redundent opgeslagen in
     ca-u_shipment.dt_ets --*/

/*--indien al een keer uitgevoerd, dan overslaan --*/
IF CAN-FIND(FIRST sp-control WHERE
                  sp-control.controlkode EQ THIS-PROCEDURE:FILE-NAME )
THEN RETURN.

/*--ivm met performance triggers disablen --*/
DISABLE TRIGGERS FOR LOAD OF ca-u_shipment.

DEF VAR cProgram                      AS CHAR NO-UNDO.
DEF VAR cAction                       AS CHAR NO-UNDO.
DEF VAR cTable                        AS CHAR NO-UNDO.
DEF VAR iTotal                        AS INT  NO-UNDO.
DEF VAR iDone                         AS INT  NO-UNDO.
DEF VAR iModulo                       AS INT  NO-UNDO.

ASSIGN cProgram =  THIS-PROCEDURE:FILE-NAME
       cAction  = ''
       iModulo  =  100.  /* om de 100 records info tonen */

FORM 'Program  :' AT 1 cProgram   NO-LABEL  FORMAT 'x(50)'    AT 12  SKIP
     'Action   :' AT 1 cAction    NO-LABEL  FORMAT 'x(50)'    AT 12  SKIP
     'Table    :' AT 1 cTable     NO-LABEL  FORMAT 'x(50)'    AT 12  SKIP
     'Total    :' AT 1 iTotal     NO-LABEL  FORMAT '9999999'  AT 12  SKIP
     'Done     :' AT 1 iDone      NO-LABEL  FORMAT '9999999'  AT 12  SKIP
     WITH FRAME a.

&GLOBAL-DEFINE mydisplay cProgram cAction cTable iTotal iDone  WITH FRAME a

ASSIGN cTable  = ''
       cAction = 'Counting..' .
DISPLAY {&mydisplay}.
/*****************************************************************************************************
   EVEN TELLEN, niet echt noodzakelijk ..
*****************************************************************************************************/
SELECT COUNT(*) INTO iTotal FROM ca-u_shipment.
DISPLAY {&mydisplay}.

/*****************************************************************************************************
    SHIPMENT BIJWERKEN
*****************************************************************************************************/
ASSIGN cTable  = 'ca-u_shipment'
       cAction = 'updating ETS' .
DISPLAY {&mydisplay}.

ASSIGN iDone = 0.
FOR EACH aa-vessel
         FIELDS(dtm_ets)
         NO-LOCK,
    EACH ca-u_shipment FIELDS(dt_ets) WHERE
         ca-u_shipment.companycode EQ aa-vessel.companycode
     AND ca-u_shipment.vesselnr    EQ aa-vessel.vesselnr
         EXCLUSIVE-LOCK TRANSACTION:
   ASSIGN iDone = iDone + 1
          ca-u_shipment.dt_ets = aa-vessel.dtm_ets.

   IF iDone MODULO iModulo EQ 0
   THEN DISPLAY {&mydisplay}.
END. /*each aa-vessel*/

ASSIGN iDone = 0.
FOR EACH ca-u_vessel_pol
         FIELDS(dt_ets)
         NO-LOCK
         WHERE ca-u_vessel_pol.dt_ets ne ? ,
    EACH ca-u_shipment FIELDS(dt_ets) WHERE
         ca-u_shipment.companycode  EQ ca-u_vessel_pol.companycode
     AND ca-u_shipment.vesselnr     EQ ca-u_vessel_pol.vesselnr
     AND ca-u_shipment.pol_portcode EQ ca-u_vessel_pol.portcode
         EXCLUSIVE-LOCK TRANSACTION:
   ASSIGN iDone = iDone + 1
          ca-u_shipment.dt_ets = ca-u_vessel_pol.dt_ets.

   IF iDone MODULO iModulo EQ 0
   THEN DISPLAY {&mydisplay}.
END. /*each ca-u_vessel_pol*/

ASSIGN iDone = 0.
FOR EACH ca-u_vessel_pol_terminal
         FIELDS(dt_ets)
         NO-LOCK
         WHERE ca-u_vessel_pol_terminal.dt_ets ne ? ,
    EACH ca-u_shipment FIELDS(dt_ets) WHERE
         ca-u_shipment.companycode  EQ ca-u_vessel_pol_terminal.companycode
     AND ca-u_shipment.vesselnr     EQ ca-u_vessel_pol_terminal.vesselnr
     AND ca-u_shipment.pol_portcode EQ ca-u_vessel_pol_terminal.pol_portcode
     AND ca-u_shipment.locationcode EQ ca-u_vessel_pol_terminal.locationcode
         EXCLUSIVE-LOCK TRANSACTION:
   ASSIGN iDone = iDone + 1
          ca-u_shipment.dt_ets = ca-u_vessel_pol_terminal.dt_ets.

   IF iDone MODULO iModulo EQ 0
   THEN DISPLAY {&mydisplay}.
END. /*each ca-u_vessel_pol_terminal*/


/*****************************************************************************************************
     registreren voor toekomstige runs dat deze script al is uitgevoerd en kan worden overgeslagen
*****************************************************************************************************/
ASSIGN cTable  = ''
       cAction = 'Done...' .
DISPLAY {&mydisplay}.

DO TRANSACTION:
   CREATE sp-control.
   ASSIGN sp-control.controlkode = THIS-PROCEDURE:FILE-NAME
          sp-control.lijst       = 'uitgevoerd op ' + STRING(TODAY,'99-99-9999') + ' ' + STRING(TIME,'HH:MM:SS')
          sp-control.uitleg      = 'Update ETS from aa-vessel to ca-u_shipment'.
END. /*transaction*/



